import './card-proj-result.css';
import {IProjResult} from "../../interfaces/card/ICardProj.ts";

export default function CardProjResult(props: IProjResult) {
    return (
        <div className="card-proj-result">
            <div className="title">
                <span className="label">{props.title}</span>
                {props.isSuccess ? <span className="success"></span> : <span className="failed"></span>}
            </div>
            {
                props.handleFeedback ? (
                    <div className="option">
                        {
                            <a href="/#" className="edit" onClick={(e) => {
                                e.preventDefault();
                                props.handleFeedback?.();
                            }}>查看详情</a>
                        }
                    </div>
                ) : <></>
            }
        </div>
    )
}